<?php
# Mantis - a php based bugtracking system

# Copyright (C) 2000 - 2002  Kenzaburo Ito - kenito@300baud.org
# Copyright (C) 2002 - 2008  Mantis Team   - mantisbt-dev@lists.sourceforge.net

# Mantis is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# Mantis is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Mantis.  If not, see <http://www.gnu.org/licenses/>.

# --------------------------------------------------------
# $Id: bug_report.php,v 1.49.2.1 2007-10-13 22:32:51 giallu Exp $
# --------------------------------------------------------

# This page stores the reported bug

require_once( 'core.php' );

$t_core_path = config_get( 'core_path' );

require_once( $t_core_path.'string_api.php' );
require_once( $t_core_path.'file_api.php' );
require_once( $t_core_path.'bug_api.php' );
require_once( $t_core_path.'custom_field_api.php' );
require_once( $t_core_path.'bugnote_api.php' );


# helper_ensure_post();

access_ensure_project_level( config_get('report_bug_threshold' ) );

$t_bug_data = new BugData;
$t_bug_data->build				= gpc_get_string( 'build', '' );
$t_bug_data->platform				= gpc_get_string( 'platform', '' );
$t_bug_data->os					= gpc_get_string( 'os', '' );
$t_bug_data->os_build				= gpc_get_string( 'os_build', '' );
$t_bug_data->version			= gpc_get_string( 'product_version', '' );
$t_bug_data->target_version		= gpc_get_string( 'target_version', '' );
$t_bug_data->fixed_in_version	= gpc_get_string( 'fixed_in_version', '' );
$t_bug_data->build				= gpc_get_string( 'build', '' );
$t_bug_data->profile_id			= gpc_get_int( 'profile_id', 0 );
$t_bug_data->handler_id			= gpc_get_int( 'handler_id', 0 );
$t_bug_data->view_state			= gpc_get_int( 'view_state', config_get( 'default_bug_view_status' ) );

$t_bug_data->category				= gpc_get_string( 'category', config_get( 'default_bug_category' ) );
$t_bug_data->reproducibility		= gpc_get_int( 'reproducibility', config_get( 'default_bug_reproducibility' ) );
$t_bug_data->severity				= gpc_get_int( 'severity', config_get( 'default_bug_severity' ) );
$t_bug_data->priority				= gpc_get_int( 'priority', config_get( 'default_bug_priority' ) );
$t_bug_data->summary				= gpc_get_string( 'summary' );
$t_bug_data->description			= gpc_get_string( 'description' );
$t_bug_data->steps_to_reproduce	= gpc_get_string( 'steps_to_reproduce', config_get( 'default_bug_steps_to_reproduce' ) );
$t_bug_data->additional_information	= gpc_get_string( 'additional_info', config_get ( 'default_bug_additional_info' ) );

$f_file					= gpc_get_file( 'file', null ); #@@@ (thraxisp) Note that this always returns a structure
# size = 0, if no file
$f_report_stay			= gpc_get_bool( 'report_stay', false );
$t_bug_data->project_id			= gpc_get_int( 'project_id' );

$t_bug_data->reporter_id		= auth_get_current_user_id();

$t_bug_data->summary			= trim( $t_bug_data->summary );

$t_bug_data->target_version		= access_has_project_level( config_get( 'roadmap_update_threshold' ), $t_bug_data->project_id ) ? gpc_get_string( 'target_version', '' ) : '';

$f_time_tracking	= gpc_get_string( 'time_tracking', '0:00' );

if(!preg_match("/\d+:\d\d/",$f_time_tracking)){
	$f_time_tracking='0:00';
};

$parrArr = explode(':',$f_time_tracking);
if(intval($parrArr[0])<0) $f_time_tracking = '0:00';
if(intval($parrArr[1])>59) $f_time_tracking = '0:00';

$d_year_submitted		=	gpc_get_string('year_submitted');
$d_month_submitted		=	gpc_get_string('month_submitted');
$d_day_submitted		=	gpc_get_string('day_submitted');
$d_hour_submitted		=	gpc_get_string('hour_submitted', date("h:m:s",time()));

if(!preg_match("/\d\d:\d\d:\d\d/", $d_hour_submitted)){
	$d_hour_submitted=date("h:m:s",time());
}
$overwrite=false;
$parrArr = explode(':',$d_hour_submitted);
if(intval($parrArr[0])>23) $overwrite=true;
if(intval($parrArr[1])>59) $overwrite=true;
if(intval($parrArr[2])>59) $overwrite=true;

if($overwrite){
	$d_hour_submitted=date("h:m:s",time());
}

$d_date_submitted = $d_year_submitted.'-'.$d_month_submitted.'-'.$d_day_submitted.' '.$d_hour_submitted;

$f_initial_status	= gpc_get_int( 'status', RESOLVED );

$f_target_version = gpc_get_string( 'target_version', '' );

# if a profile was selected then let's use that information
if ( 0 != $t_bug_data->profile_id ) {
	if ( profile_is_global( $t_bug_data->profile_id ) ) {
		$row = user_get_profile_row( ALL_USERS, $t_bug_data->profile_id );
	} else {
		$row = user_get_profile_row( $t_bug_data->reporter_id, $t_bug_data->profile_id );
	}

	if ( is_blank( $t_bug_data->platform ) ) {
		$t_bug_data->platform = $row['platform'];
	}
	if ( is_blank( $t_bug_data->os ) ) {
		$t_bug_data->os = $row['os'];
	}
	if ( is_blank( $t_bug_data->os_build ) ) {
		$t_bug_data->os_build = $row['os_build'];
	}
}

helper_call_custom_function( 'issue_create_validate', array( $t_bug_data ) );

# Validate the custom fields before adding the bug.
$t_related_custom_field_ids = custom_field_get_linked_ids( $t_bug_data->project_id );
foreach( $t_related_custom_field_ids as $t_id ) {
	$t_def = custom_field_get_definition( $t_id );
	if ( $t_def['require_report'] && ( gpc_get_custom_field( "custom_field_$t_id", $t_def['type'], '' ) == '' ) ) {
		error_parameters( lang_get_defaulted( custom_field_get_field( $t_id, 'name' ) ) );
		trigger_error( ERROR_EMPTY_FIELD, ERROR );
	}
	if ( !custom_field_validate( $t_id, gpc_get_custom_field( "custom_field_$t_id", $t_def['type'], $t_def['default_value'] ) ) ) {
		error_parameters( lang_get_defaulted( custom_field_get_field( $t_id, 'name' ) ) );
		trigger_error( ERROR_CUSTOM_FIELD_INVALID_VALUE, ERROR );
	}
}

# Create the bug
$t_bug_id = bug_create( $t_bug_data );

if(strtotime($d_date_submitted)==-1){
	#var_dump('bad date'); TODO: maybe handle this
}else{
	bug_set_field( $t_bug_id, 'date_submitted', $d_date_submitted);
}

switch($f_initial_status){
	case ASSIGNED:
		bug_assign($t_bug_id, auth_get_current_user_id());
		break;
	case RESOLVED:
		bug_resolve($t_bug_id, FIXED, $f_target_version);
		break;
	case CLOSED:
		bug_close($t_bug_id);
		break;
	case FEEDBACK:
	case ACKNOWLEDGED:
	case CONFIRMED:
	default:
		bug_set_field( $t_bug_id, 'status', $f_initial_status);
}

# Handle the file upload
if ( !is_blank( $f_file['tmp_name'] ) && ( 0 < $f_file['size'] ) ) {
	$f_file_error =  ( isset( $f_file['error'] ) ) ? $f_file['error'] : 0;
	file_add( $t_bug_id, $f_file['tmp_name'], $f_file['name'], $f_file['type'], 'bug', $f_file_error );
}

# Handle custom field submission
foreach( $t_related_custom_field_ids as $t_id ) {
	# Do not set custom field value if user has no write access.
	if( !custom_field_has_write_access( $t_id, $t_bug_id ) ) {
		continue;
	}

	$t_def = custom_field_get_definition( $t_id );
	if( !custom_field_set_value( $t_id, $t_bug_id, gpc_get_custom_field( "custom_field_$t_id", $t_def['type'], $t_def['default_value'] ) ) ) {
		error_parameters( lang_get_defaulted( custom_field_get_field( $t_id, 'name' ) ) );
		trigger_error( ERROR_CUSTOM_FIELD_INVALID_VALUE, ERROR );
	}
}

$f_master_bug_id = gpc_get_int( 'm_id', 0 );
$f_rel_type = gpc_get_int( 'rel_type', -1 );

if ( $f_master_bug_id > 0 ) {
	# it's a child generation... let's create the relationship and add some lines in the history

	# update master bug last updated
	bug_update_date( $f_master_bug_id );

	# Add log line to record the cloning action
	history_log_event_special( $t_bug_id, BUG_CREATED_FROM, '', $f_master_bug_id );
	history_log_event_special( $f_master_bug_id, BUG_CLONED_TO, '', $t_bug_id );

	if ( $f_rel_type >= 0 ) {
		# Add the relationship
		relationship_add( $t_bug_id, $f_master_bug_id, $f_rel_type );

		# Add log line to the history (both issues)
		history_log_event_special( $f_master_bug_id, BUG_ADD_RELATIONSHIP, relationship_get_complementary_type( $f_rel_type ), $t_bug_id );
		history_log_event_special( $t_bug_id, BUG_ADD_RELATIONSHIP, $f_rel_type, $f_master_bug_id );

		# Send the email notification
		email_relationship_added( $f_master_bug_id, $t_bug_id, relationship_get_complementary_type( $f_rel_type ) );
	}
}

attach_init_note($t_bug_id, $f_time_tracking, $d_date_submitted);

email_new_bug( $t_bug_id );

helper_call_custom_function( 'issue_create_notify', array( $t_bug_id ) );

html_page_top1();

if ( ! $f_report_stay ) {
	html_meta_redirect( 'view_all_bug_page.php' );
}

html_page_top2();
?>

<?php

function attach_init_note($f_bug_id, $f_time_tracking, $date){
	#$f_bug_id		= gpc_get_int( 'bug_id' );
	$f_private		= false;
	#$f_time_tracking	= gpc_get_string( 'time_tracking', '0:00' );

	#Do not attach a note if no time is specified
	if($f_time_tracking=='0:00'){
		return;
	}

	$f_bugnote_text	= string_attribute( lang_get( 'issue_created' ) );

	if ( bug_is_readonly( $f_bug_id ) ) {
		error_parameters( $f_bug_id );
		trigger_error( ERROR_BUG_READ_ONLY_ACTION_DENIED, ERROR );
	}

	access_ensure_bug_level( config_get( 'add_bugnote_threshold' ), $f_bug_id );

	$t_bug = bug_get( $f_bug_id, true );
	if( $t_bug->project_id != helper_get_current_project() ) {
		# in case the current project is not the same project of the bug we are viewing...
		# ... override the current project. This to avoid problems with categories and handlers lists etc.
		$g_project_override = $t_bug->project_id;
	}

	# @@@ VB: Do we want to differentiate email notifications for normal notes from time tracking entries?
	$t_bugnote_added = bugnote_add( $f_bug_id, $f_bugnote_text, $f_time_tracking, $f_private, $t_note_type );
	if ( !$t_bugnote_added ) {
		error_parameters( lang_get( 'bugnote' ) );
		trigger_error( ERROR_EMPTY_FIELD, ERROR );
	}
	$t_bugnote_table     	= config_get( 'mantis_bugnote_table' );
	$query = "UPDATE $t_bugnote_table
					SET date_submitted='$date', last_modified='$date'
		    		WHERE bug_id='$f_bug_id'";
	db_query( $query );

}
	?>
<br />
<div align="center"><?php
echo lang_get( 'operation_successful' ) . '<br />';
print_bracket_link( string_get_bug_view_url( $t_bug_id ), lang_get( 'view_submitted_bug_link' ) . " $t_bug_id" );
print_bracket_link( 'view_all_bug_page.php', lang_get( 'view_bugs_link' ) );

if ( $f_report_stay ) {
	?>
<p>


<form method="post" action="<?php echo 'bug_report_timed_page.php' ?>">
<input type="hidden" name="category"
	value="<?php echo $t_bug_data->category ?>" /> <input type="hidden"
	name="severity" value="<?php echo $t_bug_data->severity ?>" /> <input
	type="hidden" name="reproducibility"
	value="<?php echo $t_bug_data->reproducibility ?>" /> <input
	type="hidden" name="profile_id"
	value="<?php echo $t_bug_data->profile_id ?>" /> <input type="hidden"
	name="platform" value="<?php echo $t_bug_data->platform ?>" /> <input
	type="hidden" name="os" value="<?php echo $t_bug_data->os ?>" /> <input
	type="hidden" name="os_build"
	value="<?php echo $t_bug_data->os_build ?>" /> <input type="hidden"
	name="product_version" value="<?php echo $t_bug_data->version ?>" /> <input
	type="hidden" name="target_version"
	value="<?php echo $t_bug_data->target_version ?>" /> <input
	type="hidden" name="build" value="<?php echo $t_bug_data->build ?>" />
<input type="hidden" name="report_stay" value="1" /> <input
	type="hidden" name="view_state"
	value="<?php echo $t_bug_data->view_state ?>" /> <input type="submit"
	class="button" value="<?php echo lang_get( 'report_more_bugs' ) ?>" />
</form>
</p>
	<?php
}
?></div>

<?php html_page_bottom1( __FILE__ ) ?>
