function Pager(tableName, itemsPerPage) {
    this.tableName = tableName;
    this.itemsPerPage = itemsPerPage;
    this.currentPage = 1;
    this.pages = 0;
    this.inited = false;
    
    this.update = function(){
        var rows = document.getElementById(tableName).rows;
    	var sum = 0;
    	for(var i=1; i<rows.length; i++){
    		if(rows[i].cells[0].innerHTML.search("<p>")==-1 &&
	          		rows[i].cells[0].innerHTML.search("<P>")==-1){
	        	sum++;
	        }
    	}
        var records = sum; 
        this.pages = Math.ceil(records / itemsPerPage);
    }
    
    this.showRecords = function(from, to) {        
        var rows = document.getElementById(tableName).rows;
        var newRows = new Array();
        for(var i=1; i<rows.length; i++){
    		if(rows[i].cells[0].innerHTML.search("<p>")==-1 &&
	          		rows[i].cells[0].innerHTML.search("<P>")==-1){
	        	newRows[newRows.length] = rows[i];
	        }
    	}
        // i starts from 1 to skip table header row
        for (var i = 0; i < newRows.length; i++) {
            if (i+1 < from || i+1 > to)  
                newRows[i].style.display = 'none';
            else
                newRows[i].style.display = '';
        }
    }
    
    this.showPage = function(pageNumber) {
    	if (! this.inited) {
    		alert("not inited");
    		return;
    	}

        var oldPageAnchor = document.getElementById('pg'+this.currentPage);
        oldPageAnchor.className = 'pg-normal';
        
        this.currentPage = pageNumber;
        var newPageAnchor = document.getElementById('pg'+this.currentPage);
        newPageAnchor.className = 'pg-selected';
        
        var from = (pageNumber - 1) * itemsPerPage + 1;
        var to = from + itemsPerPage - 1;
        this.showRecords(from, to);
    }   
    
    this.prev = function() {
        if (this.currentPage > 1)
            this.showPage(this.currentPage - 1);
    }
    
    this.next = function() {
        if (this.currentPage < this.pages) {
            this.showPage(this.currentPage + 1);
        }
    }                        
    
    this.init = function() {
        var rows = document.getElementById(tableName).rows;
        var records = (rows.length - 1); 
        this.pages = Math.ceil(records / itemsPerPage);
        this.inited = true;
    }

    this.showPageNav = function(pagerName, positionId) {
    	if (! this.inited) {
    		alert("not inited");
    		return;
    	}
    	this.update();
    	var element = document.getElementById(positionId);
    	
    	var pagerHtml = '<span onclick="' + pagerName + '.prev();" class="pg-normal"> &#171 Prev </span> | ';
        for (var page = 1; page <= this.pages; page++) 
            pagerHtml += '<span id="pg' + page + '" class="pg-normal" onclick="' + pagerName + '.showPage(' + page + ');">' + page + '</span> | ';
        pagerHtml += '<span onclick="'+pagerName+'.next();" class="pg-normal"> Next &#187;</span>';            
        
        element.innerHTML = pagerHtml;
    }
}

