<?php
# Mantis - a php based bugtracking system

# Copyright (C) 2000 - 2002  Kenzaburo Ito - kenito@300baud.org
# Copyright (C) 2002 - 2007  Mantis Team   - mantisbt-dev@lists.sourceforge.net

# Mantis is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# Mantis is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Mantis.  If not, see <http://www.gnu.org/licenses/>.

# --------------------------------------------------------
# $Id: billing_inc.php,v 1.14.2.1 2007-10-13 22:32:29 giallu Exp $
# --------------------------------------------------------
?>
<?php
# This include file prints out the bug bugnote_stats

# $f_bug_id must already be defined
?>
<?php
$t_core_path = config_get( 'core_path' );

require_once( $t_core_path.'bugnote_api.php' );

require_once( $t_core_path.'project_api.php' );
require_once( $t_core_path.'bug_api.php' );
require_once( $t_core_path.'filter_api.php' );
require_once( $t_core_path.'user_api.php' );
require_once( $t_core_path.'authentication_api.php' );
require_once( $t_core_path.'access_api.php' );
require_once( 'time_tracking_helper.php' );
?>
<?php
if ( ! config_get('time_tracking_enabled') )
return;
?>

<table>
	<tr>

		<td class="right" colspan="4"><?php
		$t_stored_queries_arr = array();
		$t_stored_queries_arr = filter_db_get_available_queries();
		$t_form_name_suffix = '_billing';
		if ( count( $t_stored_queries_arr ) > 0 ) {
			?>
		<form method="get"
			name="list_queries<?php echo $t_form_name_suffix; ?>"
			action="time_tracking_page.php"><input type="hidden" name="type" value="3" />
			<?php
			if ( ON == config_get( 'use_javascript' ) ) {
				echo "<select name=\"source_query_id\" onchange=\"document.forms.list_queries$t_form_name_suffix.submit();\">";
			} else {
				PRINT '<select name="source_query_id">';
			}
			?>
		<option value="-1"><?php PRINT '[' . lang_get( 'reset_query' ) . ']' ?></option>
		<option value="-1"></option>
		<?php
		foreach( $t_stored_queries_arr as $t_query_id => $t_query_name ) {
			PRINT '<option value="' . $t_query_id . '">' . $t_query_name . '</option>';
		}
		?> </select> <input type="submit" name="switch_to_query_button"
			class="button-small" value="<?php PRINT lang_get( 'use_query' ) ?>" />
		</form>
		<form method="post" name="open_queries" action="query_view_page.php">
		<input type="submit" name="switch_to_query_button"
			class="button-small"
			value="<?php PRINT lang_get( 'open_queries' ) ?>" /></form>
			<?php
		} else {
			?>
		<form method="get" name="reset_query" action="view_all_set.php"><input
			type="hidden" name="type" value="3" /> <input type="hidden"
			name="source_query_id" value="-1" /> <input type="submit"
			name="reset_query_button" class="button-small"
			value="<?php PRINT lang_get( 'reset_query' ) ?>" /></form>
			<?php
		}?>

<?php 
if ( access_has_project_level( config_get( 'stored_query_create_threshold' ) ) ) {
	?>
	<input
			type="button" name="save_query_button" class="button-small"
			value="<?php PRINT lang_get( 'save_query' ) ?>" onclick="send()"/>
<?php }?>

		</td>
	</tr>
</table>


<a name="bugnotestats" id="bugnotestats" /><br />

			<?php
			collapse_open( 'bugnotestats' );

			$t_today = date( "d:m:Y" );
			$t_date_submitted = isset( $t_bug ) ? date( "d:m:Y", $t_bug->date_submitted ) : $t_today;

			$t_bugnote_stats_from_def = $t_date_submitted;
			$t_bugnote_stats_from_def_ar = explode ( ":", $t_bugnote_stats_from_def );
			$t_bugnote_stats_from_def_d = $t_bugnote_stats_from_def_ar[0];
			$t_bugnote_stats_from_def_m = $t_bugnote_stats_from_def_ar[1];
			$t_bugnote_stats_from_def_y = $t_bugnote_stats_from_def_ar[2];

			$t_bugnote_stats_from_d = gpc_get_int('start_day', $t_bugnote_stats_from_def_d);
			$t_bugnote_stats_from_m = gpc_get_int('start_month', $t_bugnote_stats_from_def_m);
			$t_bugnote_stats_from_y = gpc_get_int('start_year', $t_bugnote_stats_from_def_y);

			$t_bugnote_stats_to_def = $t_today;
			$t_bugnote_stats_to_def_ar = explode ( ":", $t_bugnote_stats_to_def );
			$t_bugnote_stats_to_def_d = $t_bugnote_stats_to_def_ar[0];
			$t_bugnote_stats_to_def_m = $t_bugnote_stats_to_def_ar[1];
			$t_bugnote_stats_to_def_y = $t_bugnote_stats_to_def_ar[2];

			$t_bugnote_stats_to_d = gpc_get_int('end_day', $t_bugnote_stats_to_def_d);
			$t_bugnote_stats_to_m = gpc_get_int('end_month', $t_bugnote_stats_to_def_m);
			$t_bugnote_stats_to_y = gpc_get_int('end_year', $t_bugnote_stats_to_def_y);

			$f_get_bugnote_stats_button = gpc_get_string('get_bugnote_stats_button', '');
			$f_bugnote_cost = gpc_get_int( 'bugnote_cost', '' );
			$f_project_id = helper_get_current_project();

			?>
<form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>"><input
	type="hidden" name="id"
	value="<?php echo isset( $f_bug_id ) ? $f_bug_id : 0 ?>" />
<table border="0" class="width100" cellspacing="0">
	<tr>
		<td class="form-title" colspan="4"><?php
		collapse_icon( 'bugnotestats' );
		?> <?php echo lang_get( 'time_tracking' ) ?></td>
	</tr>
	<tr class="row-2">
		<td class="category" width="25%"><?php
		$t_filter = array();
		$t_filter['do_filter_by_date'] = 'on';
		$t_filter['start_day'] = $t_bugnote_stats_from_d;
		$t_filter['start_month'] = $t_bugnote_stats_from_m;
		$t_filter['start_year'] = $t_bugnote_stats_from_y;
		$t_filter['end_day'] = $t_bugnote_stats_to_d;
		$t_filter['end_month'] = $t_bugnote_stats_to_m;
		$t_filter['end_year'] = $t_bugnote_stats_to_y;
		print_filter_do_filter_by_date(true);
		?></td>
	</tr>
	<tr>
		<td class="center" colspan="2"><input type="submit" class="button"
			name="get_bugnote_stats_button"
			value="<?php echo lang_get( 'time_tracking_get_info_button' ) ?>" />
		</td>
	</tr>

</table>
</form>
		<?php
		$prev_proj = '';
		if ( !is_blank( $f_get_bugnote_stats_button ) ) {
			$t_from = "$t_bugnote_stats_from_y-$t_bugnote_stats_from_m-$t_bugnote_stats_from_d";
			$t_to = "$t_bugnote_stats_to_y-$t_bugnote_stats_to_m-$t_bugnote_stats_to_d";
			$t_bugnote_stats = bugnote_stats_get_project_array( $f_project_id, $t_from, $t_to, $f_bugnote_cost );
			if ( is_blank( $f_bugnote_cost ) || ( (double)$f_bugnote_cost == 0 ) ) {
				$t_cost_col = false;
			}

			$t_prev_id = -1;
			?> <br />
			<?php

			function getPrettyString($key, $val){
				if($val==0 && !is_string($val)){
					return '';
				}
				$res = '';
				switch($key){
					case 'project_id':
						if($val>0){
							$res = project_get_name( $val );
						}else{
							$res='';
						}
						break;
					case 'handler_id':
						$res = user_get_name( $val );
						break;
					case 'show_category':
						$res = $val;
						break;
					case 'show_status':
						$res = get_enum_element( 'status', $val );
						break;
					case 'show_priority':
						$res = get_enum_element( 'priority', $val );
						break;
					case 'show_resolution':
						$res = get_enum_element( 'resolution', $val );
						break;
					default:
						$res = 'time_tracking_inc.php->getString:'.$val;
				}
				return $res;

			}

			function getAssocTab($name, $filterArray,$key){
				$value = $filterArray[$key];
				$text='';
				if(is_array($value)){
					foreach($value as $t_iter){
						$text = $text.getPrettyString($key,$t_iter).' ';
					}
					$text = substr($text,0,strlen($text)-1);
				}else{
					$text = $value;
				}
				?> <br>
<input name="<?php echo$name?>" value="<?php echo$text?>" size="10"
	onkeyup="filterAll(
		[
		['userFilt','username'],
		['projFilt', 'project_name'],
		['priorityFilt','priority'],
		['categoryFilt','category'],
		['statusFilt','status'],
		['resolutionFilt','resolution']
		]
		, 'timeReport', event)"
	type="text"> <?php
			}
			?> <?php
			# Set new filter values.  These are stored in a cookie
			$t_view_all_cookie_id = gpc_get_cookie( config_get( 'view_all_cookie' ), '' );
			$t_view_all_cookie = filter_db_get_filter( $t_view_all_cookie_id );

			# process the cookie if it exists, it may be blank in a new install
			if ( ! is_blank( $t_view_all_cookie ) ) {
				$t_setting_arr = filter_deserialize( $t_view_all_cookie );
				if ( false === $t_setting_arr ) {
					# couldn't deserialize, if we were trying to use the filter, clear it and reload
					# for ftype = 0, 1, or 3, we are going to re-write the filter anyways
					if ( !in_array( $f_type, array( 0, 1, 3 ) ) ) {
						gpc_clear_cookie( 'view_all_cookie' );
						error_proceed_url( 'view_all_set.php?type=0' );
						trigger_error( ERROR_FILTER_TOO_OLD, ERROR );
						exit; # stop here
					}
				}
			}

			?>

<SCRIPT LANGUAGE="javascript">
function send(){
	document.filters.sortedBy.value = 0;	
	var titleRow = document.getElementById("timeReport").tHead.rows[0];
	for(var i=0;i<titleRow.cells.length;i++){
		if(titleRow.cells[i].innerHTML.search("sorttable_")!=-1){
			document.filters.sortedBy.value = i;
			break;
		}
	}
	document.filters.submit();
}

function exportCsv() {
	var table = document.getElementById("timeReport");
	var res ="";
	for(var i=0;i<table.rows.length;i++){
		if(table.rows[i].cells[0].innerHTML.match(/<P>|<p>/g)){
			continue;
		}
		for(var j=0;j<table.rows[i].cells.length;j++){
			var cont = table.rows[i].cells[j].innerHTML;
			cont = cont.replace(/<[^>]*>/g,'');
			cont = cont.replace(/&nbsp;▾/g,'');
			cont = cont.replace(/"/g,'');
			cont = cont.replace(/,/g,' ');
			cont = cont.replace(/^\s+|\s+$/g, '');
			if(cont.match(/\d+:\d\d/)){
				var timeArr = cont.split(':');	
				cont = parseInt(timeArr[0]*60)+parseInt(timeArr[1]);
			}
			res = res+cont+',';
		}
		if(i!=(table.rows.length-1)){
		res= res+'\n';
		}
	}
	res = res.replace(/\n$/,'');
	res = res.replace(/,$/,'');
	var edit = document.getElementById("csvCode");
	edit.value = res;
	document.getElementById("csvForm").submit();
}
</SCRIPT>

<form id="csvForm" name="csvExp" method="post" action="downloadCsv.php">
<input type="hidden" id="csvCode" name="csvCode"/>
<input type="button" class="button-small" name="csvExport" onclick="exportCsv()" value="<?php echo lang_get( 'csv_export' ) ?>" heigth="30" />
</form>

<form name="filters" method="post" action="time_tracking_query_pre_store.php">
<input type="hidden" id="sortedBy" name="sortedBy" value = "<?php echo$t_setting_arr['search']?>"/>
<div id="pageNavPosition"></div>
<table id="timeReport" name="reportTable" border="0" class="sortable" cellspacing="1">
	<thead>
		<tr class="row-category-history" name="titleBar">
			<th id="project_name" class="small-caption"><?php echo lang_get( 'project_name' ) ?>
			<?php getAssocTab("projFilt", $t_setting_arr, 'project_id')?>
			</th>
			<th id="username" class="small-caption"><?php echo lang_get( 'username' ) ?>
			<?php getAssocTab("userFilt", $t_setting_arr, 'handler_id') ?></th>
			<th id="bug_id" class="small-caption"><?php echo lang_get( 'id' ) ?>
			</th>
			<th id="priority" class="small-caption"><?php echo lang_get( 'priority' ) ?>
			<?php getAssocTab("priorityFilt", $t_setting_arr, 'show_priority') ?>
			</th>
			<th id="category" class="small-caption"><?php echo lang_get( 'category' ) ?>
			<?php getAssocTab("categoryFilt", $t_setting_arr, 'show_category') ?>
			</th>
			<th id="status" class="small-caption"><?php echo lang_get( 'status' ) ?>
			<?php getAssocTab("statusFilt", $t_setting_arr, 'show_status') ?></th>
			<th id="resolution" class="small-caption"><?php echo lang_get( 'resolution' ) ?>
			<?php getAssocTab("resolutionFilt", $t_setting_arr, 'show_resolution') ?>
			</th>
			<th id="time_tracking" class="small-caption"><?php echo lang_get( 'time_tracking' ) ?>
			</th>
		</tr>

	</thead>
	<tbody>
	<?php
	$t_sum_in_minutes = 0;
	
	
	foreach ( $t_bugnote_stats as $t_item ) {		

		if(!isAllowed($t_item)){
			continue;
		}
		
		$t_sum_in_minutes += $t_item['sum_time_tracking'];
		$t_item['sum_time_tracking'] = db_minutes_to_hhmm( $t_item['sum_time_tracking'] );
		
		
		?>

		<tr class="row-2">
			<td class="small-caption"><font color="#000000"> <?php
			echo project_get_name(bug_get_field($t_item['bug_id'], 'project_id'));
			?> </font></td>
			<td class="small-caption"><font color="#000000"> <?php echo $t_item['username'] ?>
			</font></td>
			<td class="small-caption"><font color="#000000"> <?php
			$t_link = string_get_bug_view_link( $t_item['bug_id'] ) . ": " . string_display( $t_item['summary'] );
			echo $t_link;
			$t_prev_id = $t_item['bug_id'];
			?> </font></td>
			<td class="small-caption"><font color="#000000"> <?php
			echo get_enum_to_string( config_get( 'priority_enum_string' ), bug_get_field($t_item['bug_id'],'priority'));
			?> </font></td>
			<td class="small-caption"><font color="#000000"> <?php
			echo bug_get_field($t_item['bug_id'],'category');
			?> </font></td>
			<td class="small-caption"><font color="#000000"> <?php
			echo get_enum_to_string( config_get( 'status_enum_string' ), bug_get_field($t_item['bug_id'],'status')); #resolution, priority
			?> </font></td>
			<td class="small-caption"><font color="#000000"> <?php
			echo get_enum_to_string( config_get( 'resolution_enum_string' ), bug_get_field($t_item['bug_id'],'resolution')); #resolution, priority
			?> </font></td>
			<td class="small-caption"><font color="#000000"> <?php echo $t_item['sum_time_tracking'] ?>
			</font></td>
		</tr>

		<?php } # end for loop
		?>
	</tbody>
	<tfoot>
		<tr <?php echo helper_alternate_class() ?>>
			<td class="small-caption"><?php echo lang_get( 'total_time' ); ?></td>
			<td class="small-caption"></td>
			<td class="small-caption"></td>
			<td class="small-caption"></td>
			<td class="small-caption"></td>
			<td class="small-caption"></td>
			<td class="small-caption"></td>
			<td class="small-caption"><?php echo db_minutes_to_hhmm( $t_sum_in_minutes ); ?>
			</td>
		</tr>
	</tfoot>
</table>

</form>

    <script type="text/javascript">
        var pager = new Pager('timeReport', <?php echo config_get('default_limit_view')?>); 
        pager.init(); 
        pager.showPageNav('pager', 'pageNavPosition'); 
        pager.showPage(1);
    </script>
    
		<?php } # end if
		collapse_closed( 'bugnotestats' );
		?>
<table class="width100" cellspacing="0">
	<tr>
		<td class="form-title" colspan="4"><?php collapse_icon( 'bugnotestats' );
		echo lang_get( 'time_tracking' ) ?></td>
	</tr>
</table>
		<?php
	echo time();
	collapse_end( 'bugnotestats' );
?>
<script type="text/javascript">
function filterSort(ev){
	//sort using the nth column
	var edit = document.getElementById('sortedBy');
	if(edit==null) return;
	var colNo = parseInt(edit.value);
	var table = document.getElementById('timeReport');
	if(table==null) return;
	var cell = table.tHead.rows[0].cells[colNo];
	//cell0.click();
	try{
	cell.handler('filtered');
	//filter	
	if(ev==null){ //IE-Firefox compatibility	
		ev = document.createEventObject();
	}
	ev.which=13;
	ev.keyCode=13;
	filterAll(
		[
		['userFilt','username'],
		['projFilt', 'project_name'],
		['priorityFilt','priority'],
		['categoryFilt','category'],
		['statusFilt','status'],
		['resolutionFilt','resolution']
		]
		, 'timeReport', ev);
	}catch(ex){}		
}

function addLoadEvent(func) {
  var oldonload = window.onload;
  if (typeof window.onload != 'function') {
    window.onload = func;
  } else {
    window.onload = function(event) {
      if (oldonload) {
        oldonload();
      }
      func(event);
    }
  }
}

addLoadEvent( function(event){ filterSort(event);});
</script>
