<?php
# Mantis - a php based bugtracking system

# Copyright (C) 2000 - 2002  Kenzaburo Ito - kenito@300baud.org
# Copyright (C) 2002 - 2008  Mantis Team   - mantisbt-dev@lists.sourceforge.net

# Mantis is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
#
# Mantis is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Mantis.  If not, see <http://www.gnu.org/licenses/>.

	# --------------------------------------------------------
	# $Id: bug_report.php,v 1.49.2.1 2007-10-13 22:32:51 giallu Exp $
	# --------------------------------------------------------

	# This page stores the reported bug

	require_once( 'core.php' );

	$t_core_path = config_get( 'core_path' );

	require_once( $t_core_path.'string_api.php' );
	require_once( $t_core_path.'file_api.php' );
	require_once( $t_core_path.'project_api.php' );
	require_once( $t_core_path.'bug_api.php' );
	require_once( $t_core_path.'custom_field_api.php' );
	require_once( $t_core_path.'user_api.php' );	

	
	
	# helper_ensure_post();

	if ( !access_has_project_level( config_get( 'stored_query_create_threshold' ))){
		return;
	}
	
	$t_projFilt						= gpc_get_string('projFilt', '' );
	$t_userFilt						= gpc_get_string('userFilt', '' );
	$t_priorityFilt						= gpc_get_string('priorityFilt', '' );
	$t_categoryFilt						= gpc_get_string('categoryFilt', '' );
	$t_statusFilt						= gpc_get_string('statusFilt', '' );
	$t_resolutionFilt						= gpc_get_string('resolutionFilt', '' );
	$t_sortedBy						=gpc_get_int('sortedBy',-1);

	
	$f_projFilt = explode(' ', $t_projFilt);
	$f_userFilt = explode(' ', $t_userFilt);
	$f_priorityFilt = explode(' ', $t_priorityFilt);
	$f_categoryFilt = explode(' ', $t_categoryFilt);
	$f_statusFilt = explode(' ', $t_statusFilt);
	$f_resolutionFilt = explode(' ', $t_resolutionFilt);
	$f_sortedBy = $t_sortedBy;
	
	for($i=0;$i<sizeof($f_projFilt);$i++){
		$lastProjId = getLastProjId();
		for($j=1;$j<=$lastProjId;$j++){
			if(!project_exists($j)){
				continue;
			}
			if(!empty($f_projFilt[$i]))
			if(substr_count(strtolower(project_get_name($j)), strtolower($f_projFilt[$i]))>0){
				$f_projFilt[$i] = project_get_id_by_name(project_get_name($j));
				break;
			}
		}
	}
	
	for($i=0;$i<sizeof($f_userFilt);$i++){
		$lastUserId = getLastUserId();
		for($j=1;$j<=$lastUserId;$j++){
			if(!user_exists($j)){
				continue;
			}
			if(!empty($f_userFilt[$i]))
			if(substr_count(strtolower(user_get_name($j)), strtolower($f_userFilt[$i]))>0){
				$f_userFilt[$i] = user_get_id_by_name(user_get_name($j));
				break;
			}
		}
	}

	$priorTable = get_enum_to_array( config_get( 'priority_enum_string' ) );
	for($i=0;$i<sizeof($f_priorityFilt);$i++){
		foreach($priorTable as $key => $val){
			if(!empty($val) && !empty($f_priorityFilt[$i]))
			if(substr_count(strtolower($val), strtolower($f_priorityFilt[$i]))>0){
				$f_priorityFilt[$i] = $key;
				break;
			}
		}
	}
	$statusTable = get_enum_to_array( config_get( 'status_enum_string' ) );
	for($i=0;$i<sizeof($f_statusFilt);$i++){
		foreach($statusTable as $key => $val){
			if(!empty($val) && !empty($f_statusFilt[$i]))
			if(substr_count(strtolower($val), strtolower($f_statusFilt[$i]))>0){
				$f_statusFilt[$i] = $key;
				break;
			}
		}
	}	

	$resolutionTable = get_enum_to_array( config_get( 'resolution_enum_string' ) );
	for($i=0;$i<sizeof($f_resolutionFilt);$i++){
		foreach($resolutionTable as $key => $val){
			if(!empty($val) && !empty($f_resolutionFilt[$i]))
			if(substr_count(strtolower($val), strtolower($f_resolutionFilt[$i]))>0){
				$f_resolutionFilt[$i] = $key;
				break;
			}
		}
	}
	
	#$t		= auth_get_current_user_id();

	#$t_bug_data->target_version		= access_has_project_level( config_get( 'roadmap_update_threshold' ), $t_bug_data->project_id ) ? gpc_get_string( 'target_version', '' ) : '';

		# Set new filter values.  These are stored in a cookie
	$t_view_all_cookie_id = gpc_get_cookie( config_get( 'view_all_cookie' ), '' );
	$t_view_all_cookie = filter_db_get_filter( $t_view_all_cookie_id );

	$t_cookie_version = config_get( 'cookie_version' );
	$t_default_show_changed = config_get( 'default_show_changed' );
#array( META_FILTER_ANY )
	
		# Update filters
				log_event( LOG_FILTERING, 'billing_query_pre_store.php: Update filters' );
				$t_setting_arr['show_category'] = $f_categoryFilt;
				$t_setting_arr['show_status'] = $f_statusFilt;
				$t_setting_arr['handler_id'] = $f_userFilt;
				$t_setting_arr['project_id'] = $f_projFilt;
				$t_setting_arr['search'] = $f_sortedBy;
				$t_setting_arr['show_resolution'] = $f_resolutionFilt;
				$t_setting_arr['show_priority'] = $f_priorityFilt;
	
	$tc_setting_arr = filter_ensure_valid_filter( $t_setting_arr );

	$t_settings_serialized = serialize( $tc_setting_arr );
	$t_settings_string = $t_cookie_version . '#' . $t_settings_serialized;

	# If only using a temporary filter, don't store it in the database
	$f_temp_filter=0;
	if ( !$f_temp_filter ) {
		# Store the filter string in the database: its the current filter, so some values won't change
		$t_project_id = helper_get_current_project();
		$t_project_id = ( $t_project_id * -1 );
		$t_row_id = filter_db_set_for_current_user( $t_project_id, false, '', $t_settings_string );

		# set cookie values
		gpc_set_cookie( config_get( 'view_all_cookie' ), $t_row_id, time()+config_get( 'cookie_time_length' ), config_get( 'cookie_path' ) );
	}
	print_header_redirect('query_store_page.php');
	
	html_begin();
	#html_head_begin();
	html_css();
		html_content_type();
		html_page_top2();
		
		html_page_bottom1( __FILE__ );
?>	
<?php

function getLastProjId(){
	$t_table = config_get( 'mantis_project_table' );
		
	$query = "SELECT MAX(id) AS last_id
			FROM $t_table";
	$result = db_query( $query );
 	$row = db_fetch_array( $result );
	return intval($row['last_id']);
}

function getLastUserId(){
	$t_table = config_get( 'mantis_user_table' );
		
	$query = "SELECT MAX(id) AS last_id
			FROM $t_table";
	$result = db_query( $query );
 	$row = db_fetch_array( $result );
	return intval($row['last_id']);
}

?>